B=xlsread('B.xlsx');
obs=xlsread('obs.xlsx');
n=1000; % iteration number
m=size(B,1);
m_obs=0.1*m*m;
X=zeros(3,m,m);
s=10;
lambda=0.005;
beta=0.1;
t=zeros(n,1);
for i=1:2
    for j=1:m_obs
        t(i)=t(i)+0.5*(X(mod(i,3)+1,obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2)))^2;
    end
end
theta=zeros(n,1);
theta(2)=1;
Y=zeros(100,100);
for i=2:n
    nabla_fy=zeros(m,m);
    for j=1:m_obs
        nabla_fy(obs(j,1),obs(j,2))=Y(obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2));
    end  % compute \nabla f(Y)
    bool=0;
    while true
        grad_f=Y-s*nabla_fy; % Y-\frac{ns}{2n+4}\nabla f(Z)
        [U,Sigma,V]=svd(grad_f);
        Sigma=max(Sigma-s*lambda*eye(m),zeros(m));
        x_t=U*Sigma*V';
        f_x_t=F2obs(x_t,B,obs,m_obs);
        f_Y=F2obs(Y,B,obs,m_obs);
        if (f_x_t<f_Y+sum(sum((x_t-Y).*nabla_fy))+1/(2*s)*norm(x_t-Y,'fro'))
            break;
        end
        s=s*beta;
    end
    X(mod(i,3)+1,:,:)=x_t;
    theta(i+1)=(1+sqrt(1+4*theta(i)*theta(i)))/2;
    Y=X(mod(i,3)+1,:,:)+((theta(i)-1)/theta(i+1))*(X(mod(i,3)+1,:,:)-X(mod(i-1,3)+1,:,:));
    Y=reshape(Y,m,m);
    for j=1:m_obs
        t(i)=t(i)+0.5*(X(mod(i,3)+1,obs(j,1),obs(j,2))-B(obs(j,1),obs(j,2)))^2;
    end
    t(i)=t(i)+lambda*sum(diag(Sigma));
end
semilogy((1:10:n),t(1:10:n)-0.02810523108535746203417993,'ok','MarkerSize',3);
xlabel('n');
ylabel('$|F-F^*|$','Interpreter','LaTeX');
hold on;
%plot(t);